% maskFigureType types
%   1=2^0 :   ln(C(r))           vs  ln(r)
%   2=2^1 :   d ln(C(r))/d lnr   vs ln(r)    (i.e. this is the SLOPE of the first graph type
function [ rgDim, rgrgEpsilon, rgrgDEstimatedCofEpsilon ] = DetermineAndDisplayCorrDimensionFromTimeSeriesForRgEmbDims(aTimeSeries, ctDesiredDistances, strFigureName, rgDims, maskFigureType, ctSlopeEstimationGridpoints, fRetainData, dMinIndexDist)
    figure;
    title(strFigureName,'FontSize', 12);
    hold on;
    i = 1;

    if ~fRetainData
        % assign dummy data since not being used
        rgDim=0;
        rgrgEpsilon=0;
        rgrgDEstimatedCofEpsilon=0;
    end 
    
    for ctEmbeddingDimension = rgDims
        [ rgEpsilon, rgDEstimatedCofEpsilon ] = DetermineAndDisplayCorrelationDimensionFromTimeSeriesOnExistFig(aTimeSeries, ctEmbeddingDimension, ctDesiredDistances, strFigureName, maskFigureType, ctSlopeEstimationGridpoints, dMinIndexDist);
        
        if fRetainData 
            % cannot use plain multidimensional array here b/c for different
            % dimensions, may have different # of elements returned
            rgrgEpsilon{i} = [ rgEpsilon ];
            rgrgDEstimatedCofEpsilon{i} =  [ rgDEstimatedCofEpsilon ];
            rgDim(i) = ctEmbeddingDimension;
            i = i + 1;
        end
    end
    hold off;
end