function r=SelectRandomDistancesFromOnTheFlyEmbeddingOfTimeSeries(aTimeSeries, ctEmbeddingDimension, ctDesiredDistances, dMinDist, dMinIndexDist)
    iDerivedDistances = 1;
    N = length(aTimeSeries); % last index 

%   Deprecated NDO 7-14-2006    epsilonNotMaxDist = EstimateMaxEmbeddingDistanceFromTimeSeries(aTimeSeries,max(100,length(aTimeSeries)/10), ctEmbeddingDimension);

    % preallocate critical arrays for efficiency
    rTmp = zeros(1,ctDesiredDistances);

    while iDerivedDistances  <= ctDesiredDistances      % iDerivedDistances 1 based; if want 1, need to do at least 1 loop
        % ok, first select a random pair of points in the embedded space
        ctAvailableIndicesWithCtEmbeddingDimensionElts = N - (ctEmbeddingDimension - 1) - 1;
        i = unidrnd(ctAvailableIndicesWithCtEmbeddingDimensionElts);   % only going from 1 to N - (ctEmbeddingDimension - 1) - 1 because we can't find j if we use i=N - (ctEmbeddingDimension - 1) , 
        %j = i + unidrnd(N - i - (ctEmbeddingDimension - 1)); % going from i+1 to N (i + N - i )
        
        % ok, with j we need to be careful, for two reasons
        %   1) we want a uniform joint distribution.  This means that we
        %      can't have i be uniformly drawn between 1 and the max index
        %      and then just draw j uniformly between i+1 and the max index
        %      (this would give joint samples with j high higher chance of
        %      being chosen
        %   2) we don't want i=j.  This is because we want to measure
        %      the distance between DIFFERENT points

        fFirstTime = true;          % needed to handle other condition not being set until after first iteration
        j = i;                      % dead value (always overwritten), but should be initialized to something to appease matlab (for reference in abs(i-j), even though short-circuited first time)
        while fFirstTime || abs(i-j) < dMinIndexDist
            fFirstTime = false;
            jContinuous = unidrnd(ctAvailableIndicesWithCtEmbeddingDimensionElts - 1);   % we want NO chance of getting i.  to do this, we will treat as two possible ranges
            if jContinuous < i 
                j = jContinuous;
            else
                j = jContinuous + 1;    % ok, if jContinuous >= i, just bump it up by 1 to leave space for i (no chance of getting i)
            end
        end
        
        % ok, now retrieve the embedded points corresponding to these
        % points in the time series
        
        v1 = [ aTimeSeries(i:i+ctEmbeddingDimension-1) ];
        v2 = [ aTimeSeries(j:j+ctEmbeddingDimension-1) ];
        
        diffVect = v1 - v2;
        d = sqrt(dot(diffVect, diffVect)) ;
         
%   Deprecated NDO 7-14-2006        if d <= epsilonNotMaxDist && d >= dMinDist
        if d >= dMinDist
            if  d == 0
               d=.1;       % guard against chance that get zero distance (causing problems with our log founction
            end
            rTmp(iDerivedDistances) = d;
            iDerivedDistances = iDerivedDistances + 1;
        end     % else, just try again!
    end
    
    r = rTmp(1:(iDerivedDistances-1));
end